
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Qa_scorecardsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const qa_scorecards = await db.qa_scorecards.create(
            {
                id: data.id || undefined,
        
        category_name: data.category_name
        ||
        null
            ,
            
        category_score: data.category_score
        ||
        null
            ,
            
        max_score: data.max_score
        ||
        null
            ,
            
        comments: data.comments
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await qa_scorecards.setQa_evaluation( data.qa_evaluation || null, {
            transaction,
        });
        
        await qa_scorecards.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return qa_scorecards;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const qa_scorecardsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                category_name: item.category_name
            ||
            null
            ,
            
                category_score: item.category_score
            ||
            null
            ,
            
                max_score: item.max_score
            ||
            null
            ,
            
                comments: item.comments
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const qa_scorecards = await db.qa_scorecards.bulkCreate(qa_scorecardsData, { transaction });

        // For each item created, replace relation files
        

        return qa_scorecards;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const qa_scorecards = await db.qa_scorecards.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.category_name !== undefined) updatePayload.category_name = data.category_name;
        
        
        if (data.category_score !== undefined) updatePayload.category_score = data.category_score;
        
        
        if (data.max_score !== undefined) updatePayload.max_score = data.max_score;
        
        
        if (data.comments !== undefined) updatePayload.comments = data.comments;
        
        
        updatePayload.updatedById = currentUser.id;

        await qa_scorecards.update(updatePayload, {transaction});

        
        
        if (data.qa_evaluation !== undefined) {
            await qa_scorecards.setQa_evaluation(
              
              data.qa_evaluation,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await qa_scorecards.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return qa_scorecards;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const qa_scorecards = await db.qa_scorecards.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of qa_scorecards) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of qa_scorecards) {
                await record.destroy({transaction});
            }
        });


        return qa_scorecards;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const qa_scorecards = await db.qa_scorecards.findByPk(id, options);

        await qa_scorecards.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await qa_scorecards.destroy({
            transaction
        });

        return qa_scorecards;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const qa_scorecards = await db.qa_scorecards.findOne(
            { where },
            { transaction },
        );

        if (!qa_scorecards) {
            return qa_scorecards;
        }

        const output = qa_scorecards.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.qa_evaluation = await qa_scorecards.getQa_evaluation({
            transaction
        });
        
        
        output.organizations = await qa_scorecards.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.qa_evaluations,
        as: 'qa_evaluation',
        
        where: filter.qa_evaluation ? {
          [Op.or]: [
            { id: { [Op.in]: filter.qa_evaluation.split('|').map(term => Utils.uuid(term)) } },
            {
              interaction_reference: {
                [Op.or]: filter.qa_evaluation.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.category_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'qa_scorecards',
                        'category_name',
                        filter.category_name,
                    ),
                };
            }
            
            if (filter.comments) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'qa_scorecards',
                        'comments',
                        filter.comments,
                    ),
                };
            }
            

            
            

            
            if (filter.category_scoreRange) {
                const [start, end] = filter.category_scoreRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    category_score: {
                    ...where.category_score,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    category_score: {
                    ...where.category_score,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.max_scoreRange) {
                const [start, end] = filter.max_scoreRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    max_score: {
                    ...where.max_score,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    max_score: {
                    ...where.max_score,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.qa_scorecards.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'qa_scorecards',
                        'category_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.qa_scorecards.findAll({
            attributes: [ 'id', 'category_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['category_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.category_name,
        }));
    }

    
};

